﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ListView3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            setGUI();
        }


        private void setGUI()
        {
            listView1.View = View.Details;		// Report vs. Details
            listView1.LabelEdit = true;		// EditModus
            listView1.AllowColumnReorder = true;	// Spalten verschieben
            listView1.FullRowSelect = true;		// zeilenweise markieren
            listView1.GridLines = true;		// Gitterlinien

            // Sortiere den ersten Eintrag (Alphanumerisch)
//            listView1.Sorting = SortOrder.Ascending;

            // Spalten
            listView1.Columns.Add("Name", 150, HorizontalAlignment.Left);
            listView1.Columns.Add("Matrnr", 60, HorizontalAlignment.Left);


            // Symbole (small und large)
            ImageList imageListSmall = new ImageList();
            ImageList imageListLarge = new ImageList();

            // Initialize the ImageList objects with bitmaps.
            imageListSmall.Images.Add(Bitmap.FromFile("MySmallImage1.bmp"));
            imageListSmall.Images.Add(Bitmap.FromFile("MySmallImage2.bmp"));
            imageListLarge.Images.Add(Bitmap.FromFile("MyLargeImage1.bmp"));
            imageListLarge.Images.Add(Bitmap.FromFile("MyLargeImage2.bmp"));

            // Zuweisung
            listView1.LargeImageList = imageListLarge;
            listView1.SmallImageList = imageListSmall;

            CStudent std = new CStudent("Meyer",14721);
            Add(std);

            std = new CStudent("Schulze", 16234);
            Add(std);

            std = new CStudent("Brandt", 14234);
            Add(std);

            std = new CStudent("Schmidt", 17431);
            Add(std);

        }

        private void Add(CStudent std)
        {
            ListViewItem item = new ListViewItem( std.name, 0);  // 0 = 1. Bild
            item.SubItems.Add( std.matrnr.ToString() );
            item.Tag = std;                                                     // NEU
            listView1.Items.Add(item);
        }


        // hier wird nun mit der aktuellen Position das angehängte Objekt geholt
        // Tag Attribut
        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            CStudent std;
            for (int i = 0; i < listView1.SelectedItems.Count; i++)
            {
                std = (CStudent) listView1.SelectedItems[i].Tag;
                Memo1.Text = "Student: " + std.name + "\r\n" + "Matrnr: " + std.matrnr.ToString();
            }
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string sStr = "";
            for (int i = 0; i < listView1.SelectedItems.Count; i++)
            {
                sStr = sStr + listView1.SelectedItems[i].Text + "\r\n";
            }
            Memo1.Text = sStr;  // MessageBox.Show(sStr);
        }

        private void BnAdd_Click(object sender, EventArgs e)
        {
            CStudent std;
            String sStr= textBox1.Text.Trim();
            if (sStr.Equals("")) return;

            std = new CStudent(sStr, (int) numericUpDown1.Value);
            Add(std);
        }

    }
}
